clc
clear
% close all
inpath='M:\icoadsv3\paper\data';
var1=ncread('ind_yymm_slp.nc','SLP');
var2=ncread('monthly_slp.nc','SLP');
lon1=ncread('monthly_slp.nc','XAXIS');
lat1=ncread('monthly_slp.nc','YAXIS');
enso0=csvread('oni.csv');


%%
% section which derives the EOF modes from anomalies of individual year
% month summaries of SLP
years1=1965:2017;
enso_sstanom=enso0(2:end,3:end);
enso_sstanom=reshape(enso_sstanom',1,840);
enso_sstanom=enso_sstanom(1,7:840);   % from 1951 to 2020
clear temp1 temp2 datenum_array slp_anom1
cc=1;
enso(1:636,1)=NaN;
slp_anom1(1:101,1:62,1:636)=NaN;
datenum_array(1:636,1)=NaN;
for ii=1:numel(years1)
    yy=years1(ii);
    for mm=1:12
        enso(cc,1)=enso_sstanom((yy-1951)*12+mm);
        slp_anom1(:,:,cc)=var1(:,:,1,(yy-1961)*12+mm)-var2(:,:,mm);
        datenum_array(cc,1)=datenum(yy,mm,1);
        cc=cc+1; count1(cc,1)=yy; count1(cc,2)=mm;
    end    
end
[slp_anom_eof_maps1,slp_anom_pc1,expvar1] = eof(slp_anom1(:,:,1:636),4);

clear ind;
ind=find((enso<0.5) & (enso>-0.5));
enso1=enso; enso1(ind)=NaN;
enso2(1:636,1)=NaN;
enso1(163)=-0.4;  %these five indices correspond to the years 1990 and 2017 when ONI = 0.4 deg Celsius
enso1(164)=-0.4;
enso1(165)=-0.4;
enso1(629)=0.4;
enso1(630)=0.4;


%%
% to plot

line1=repmat(std(slp_anom_pc1(1,:)),636,1);  
line2=repmat(-1*std(slp_anom_pc1(1,:)),636,1);  
line3=repmat(150,636,1);
close
[ax, h1, h2]=plotyy(datenum_array,slp_anom_pc1(1,:),datenum_array,enso1','plot','plot');
set(gca,'XTick',[]); set(gca,'YTick',[]);
set(h1,'LineWidth', 1.5, 'Marker','o');
set(h2, 'LineWidth', 1.5, 'Marker','*');
set(ax(1),'YLim',[-150 150]);
set(ax(1),'YTick',[-150 -100 -50 0 50 100 150],'FontSize',16,'FontWeight','bold');
set(ax(2),'YLim',[-5 5]);
set(ax(2),'YTick',[-5 -4 -3 -2 -1 0 1 2 3 4 5],'FontSize',16,'FontWeight','bold');
ylabel(ax(1),'FIRST MODE PRINCIPAL COMPONENTS OF SLP ANOMALIES  ','FontSize',14,'FontWeight','bold');
ylabel(ax(2),'OCEAN NINO INDEX ^oC (-ve=LaNina; +ve=ElNino)','FontSize',14,'FontWeight','bold');
set(ax(1),'XLim',[datenum_array(1,1) datenum_array(636,1)]);
set(ax(2),'XLim',[datenum_array(1,1) datenum_array(636,1)]);
hold on;
plot(datenum_array,line1,'LineWidth',1.3,'Color','k','LineStyle','--');
plot(datenum_array,line2,'LineWidth',1.3,'Color','k','LineStyle','--');
plot(datenum_array,zeros(636,1),'LineWidth',1.3,'Color','k','LineStyle','--');
set(gca,'XTick',linspace(datenum_array(1,1),datenum_array(636-1,1),40),'FontSize',13.5,'FontWeight','bold');
set(gca,'XTickLabelRotation',90);
datetick('x','yyyy-mm','keeplimits','keepticks');
box(ax(1),'off');
plot(datenum_array,line3,'Color','k');
grid  on;

%%
%scatter plot
close
enso1(311)=NaN;
enso1(312)=NaN;
enso1(629)=NaN;
enso1(630)=NaN;
xaxis=enso1';
yaxis=slp_anom_pc1(1,:);
plot(xaxis,yaxis,'ob','MarkerSize',5,'MarkerFaceColor','b');
hold on;
box on;
corrr=corrcoef(xaxis,yaxis,'rows','pairwise');
text(-2.5,100.5,sprintf('R= %5.2f \nNum.of.Observations= %3d',corrr(2),367),'FontSize',16,'FontWeight','bold','Color','b');
xlim([-3 3]);
ylim([-150 150]);
set(gca,'xtick',(-3:1:3));
set(gca,'ytick',(-150:20:150));
hline1=lsline;
hline1.Color='k';
hline1.LineStyle='- -';
hline1.LineWidth=2;
grid on;
set(findobj(gcf,'type','axes'),'FontName','Arial','FontSize',14,'FontWeight','Bold', 'LineWidth', 2);
xlabel('ONI  (^oC)','FontSize',16,'FontWeight','bold','Color','k');
ylabel('EOF-1 PC of SLPA','FontSize',16,'FontWeight','bold','Color','k');
title('Correlation between first mode principal components of SLPA and ONI');

%%

% defining the four categories
clear el_tio la_tio el_ntio la_ntio
el_tio= [1965,1982,1986,1987,1992,1993,1994, 1997,2002,2015,2016];
el_ntio=[1966,1968,1972,1977,1979,2004,2006]; 
la_tio=[1970,1971,1973,1974,1975,1976,1984,1985,1988,1998,2000,2007,2008,2010,2011,2012]; 
la_ntio=[1967,1995,1999,2005,2017];

clear yy_str categ;
markers = {'+','o','*','.','x','s','d','^','v','>','<','p','h','+','o','*'};

%%
%this section is for making spatial composites of years under each category
%for months june to november
clc
close
categ={'la_tio', 'la_ntio', 'el_tio', 'el_ntio'};% ,'all_years'};
clear slp_anom1 sst_anom1 slp_compo sst_compo uwind_anom1 uwind_compo 
names={'La_TIO', 'La_nTIO', 'El_TIO', 'El_nTIO'};

slp_compo(1:101,1:62,1:4)=0;
for jj=1:length(categ)
    clear years; years=eval(categ{jj});
    cc=1;
%     slp_anom1(1:101,1:62,1:200)=0;
for ii=1:numel(years)
    yy=years(ii);
    for mm=6:11
        slp_anom1(:,:,cc)=var1(:,:,1,(yy-1961)*12+mm)-var2(:,:,mm);
        cc=cc+1; 
    end    
end
slp_compo(:,:,jj)=nanmean(slp_anom1(:,:,:),3); clear slp_anom1
end

for jj=1:length(categ)
    type=names{jj};
    mfig_func_toplot_spatialplot_from2ddata1(2,2,jj,lon1,lat1,slp_compo(:,:,jj),-1.8,0.2,1.8,100,[type(1:2) '\' type(3:end)],1); %(a self written function to plot spatial plots)
    set(gca,'YTick',[-30 -20 -10  0  10 20 30],'FontSize',15,'FontWeight','bold');
    set(gca,'XTick',[20 40 60 80 100 120],'FontSize',15,'FontWeight','bold');
end


%%
% Time series  for EIO (-10S-5N, 90E-110E)
%
% picking the  data for EIO
clc
close
ind_lon=find(lon1>=90 & lon1<=110);
ind_lat=find(lat1>=-10 & lat1<=5);
eio_slp=var1(ind_lon,ind_lat,:,:);
eio_slp_mm=var2(ind_lon,ind_lat,:,:);
categ={'la_tio', 'la_ntio', 'el_tio', 'el_ntio'};
names={'La_TIO', 'La_nTIO', 'El_TIO', 'El_nTIO'};
slp_ts(1:12,1)=NaN;
for jj=1:numel(categ)
    subplot(2,2,jj);
    
    years=eval(categ{jj});
    type=names{jj};
    mean(1:12,1)=0;
    for ii=1:numel(years)
        yy=years(ii);
        for mm=1:12
            slp_ts(mm,1)=nanmean(nanmean(eio_slp(:,:,1,(yy-1961)*12+mm)-eio_slp_mm(:,:,mm)));
        end
        plot(slp_ts(:,1),'Marker',markers{ii},'LineWidth', 1.5); hold on;
        mean(1:12,1)=mean(1:12,1)+slp_ts(1:12,1); clear slp_ts;
    end
    legend(num2str((eval(categ{jj}))'),'Location','NorthEastOutside','FontSize',10,'FontWeight','bold');
    plot(mean(:,1)/numel(years),'LineWidth',1.5,'LineStyle','-.','Color','k'); title([type(1:2) '\' type(3:end)]); clear mean; hold on;
    set(gca,'YTick',[-4 -3 -2 -1 0 1 2 3 4],'FontSize',15,'FontWeight','bold');
    set(gca,'XTick',[1 2 3 4 5 6 7 8 9 10 11 12],'FontSize',15,'FontWeight','bold');
    grid on;
end


